/*
    tcptest - Web server stress test
    Copyright (C) 1999  Scott Donoho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/                                        

#include "tcptest.h"

/* 
 * read N bytes from socket
 */
int readn(int fd, char *ptr, int nbytes)
{
	int nleft, nread;

	nleft = nbytes;
	while(nleft > 0){
		nread = read(fd,ptr,nleft);
		if(nread < 0)
			return(nread);
		else if(nread == 0)
			break;

		nleft -= nread;
		ptr += nread;
	}
	return(nbytes - nleft);
}
		

/*
 * write N bytes from socket
 */
int writen(int fd, char *ptr, int nbytes)
{
	int nleft, nwritten;

	nleft = nbytes;
	while(nleft > 0){
		nwritten = write(fd,ptr,nleft);
		if(nwritten <= 0)
			return(nwritten);

		nleft -= nwritten;
		ptr += nwritten;
	}
	return(nbytes - nleft);
}

/*
 * Calc true numbers using K,k,M,m
 */
long parse_num(char *str)
{
	char tmp[64];
	long mult=1;
	int i, done=0;

	memset(tmp,0,sizeof(tmp));
	for(i=0;i<=strlen(str);i++){
		if(done)
			break;
		if(isdigit(str[i]))
			tmp[i] = str[i];
		else{
			if(str[i] == 'k' || str[i] == 'K')
				mult = 1024;
			if(str[i] == 'm' || str[i] == 'M')
				mult = 1024*1024;
			done = 1;
		}
	}
	if(i >= 1)
		return((atol(tmp))*mult);
	else
		return(-1);
}

/* 
 *
 * Psuedo-Random number generator 
 *    Return a random number: max >= N >= min
 *
 */
int rand_int(int seed, int min, int max)
{
	float Max;
	int N;

	Max = max-min+1;
	srand(seed);
	N = min+(int)(Max*rand()/(RAND_MAX+1.0));
	return(N);
}

